]> git.donarmstrong.com Git - deb_pkgs/autorandr.git/blobdiff - autorandr
Merge remote-tracking branch 'mtahmed/master'
[deb_pkgs/autorandr.git] / autorandr
index c603473529ba788e8194664dd5ef0caf0954adb7..08725363e1627a52bb2f2f7bcbb7162644c754c9 100755 (executable)
--- a/autorandr
+++ b/autorandr
@@ -1,6 +1,6 @@
 #!/bin/sh
 #
-# Automatically select a display configuration based on connected devives
+# Automatically select a display configuration based on connected devices
 #
 # Stefan Tomanek <stefan.tomanek@wertarbyte.de>
 #
 # applications about it.
 #
 #
-# While the script uses xrandr by defult, calling it by the name "autodisper"
+# While the script uses xrandr by default, calling it by the name "autodisper"
 # or "auto-disper" forces it to use the "disper" utility, which is useful for
 # controlling nvidia chipsets. The formats for fingerprinting the current setup
 # and saving/loading the current configuration are adjusted accordingly.
 
 XRANDR=/usr/bin/xrandr
 DISPER=/usr/bin/disper
+XDPYINFO=/usr/bin/xdpyinfo
 PROFILES=~/.autorandr/
 CONFIG=~/.autorandr.conf
 
@@ -61,12 +62,16 @@ LOAD_METHOD="load_cfg_xrandr"
 SCRIPTNAME="$(basename $0)"
 # when called as autodisper/auto-disper, we assume different defaults
 if [ "$SCRIPTNAME" = "auto-disper" ] || [ "$SCRIPTNAME" = "autodisper" ]; then
+       echo "Assuming disper defaults..." >&2
        FP_METHODS="setup_fp_disper"
        CURRENT_CFG_METHOD="current_cfg_disper"
        LOAD_METHOD="load_cfg_disper"
 fi
 
-test -f $CONFIG && . $CONFIG 
+if [ -f $CONFIG ]; then
+       echo "Loading configuration from '$CONFIG'" >&2
+       . $CONFIG
+fi
 
 setup_fp_xrandr_edid() {
        $XRANDR -q --verbose | awk '
@@ -97,7 +102,9 @@ setup_fp() {
        local FP="";
        for M in $FP_METHODS; do
                FP="$($M)"
-               [ -n "$FP" ] && break;
+               if [ -n "$FP" ]; then
+                       break
+               fi
        done
        if [ -z "$FP" ]; then
                echo "Unable to fingerprint display configuration" >&2
@@ -107,16 +114,37 @@ setup_fp() {
 }
 
 current_cfg_xrandr() {
-       $XRANDR -q | awk '
-       /^[^ ]+ disconnected / {
-        print "output "$1;
-               print "off";
-       }
-       /^[^ ]+ connected / {
-               split($3, A, "+");
+       local PRIMARY_SETUP="";
+       if [ -x "$XDPYINFO" ]; then
+               PRIMARY_SETUP="$($XDPYINFO -ext XINERAMA | awk '/^  head #0:/ {printf $3 $5}')"
+       fi
+       $XRANDR -q | awk -v primary_setup="${PRIMARY_SETUP}" '
+       # display is connected and has a mode
+       /^[^ ]+ connected [^(]/ {
                print "output "$1;
+               if ($3 == "primary") {
+                       print $3
+                       split($4, A, "+")
+                       $4=$5
+               }
+               else {
+                       split($3, A, "+");
+                       if (A[1] A[2] "," A[3] == primary_setup)
+                               print "primary";
+               }
                print "mode "A[1];
                print "pos "A[2]"x"A[3];
+               if ($4 !~ /^\(/) {
+                       print "rotate "$4;
+               }
+               next;
+       }
+       # disconnected or disabled displays
+       /^[^ ]+ (dis)?connected / ||
+       /^[^ ]+ unknown connection / {
+               print "output "$1;
+               print "off";
+               next;
        }'
 }
 
@@ -125,7 +153,7 @@ current_cfg_disper() {
 }
 
 current_cfg() {
-       $CURRENT_METHOD;
+       $CURRENT_CFG_METHOD;
 }
 
 blocked() {
@@ -146,11 +174,32 @@ config_equal() {
 }
 
 load_cfg_xrandr() {
-       sed 's!^!--!' "$1" | xargs $XRANDR
+       # sed 1: Prefix arguments with "--"
+       # sed 2: Merge arguments into one line per output
+       # sed 3: Merge into two lines, all --off outputs in the first one
+       sed 's/^/--/' "$1" | sed -e '
+               :START
+               /\n--output/{P;D}
+               s/\n/ /
+               N;bSTART' | sed -e '
+                       ### First line
+                       / --off/{
+                               G
+                               # Merge if next line contains --off
+                               s/\n\([^\n]* --off\)/ \1/
+                               h
+                               $!d;b
+                       }
+                       ### Last line
+                       H;x
+                       # Merge if previous line contains --mode
+                       s/\(--mode [^\n]*\)\n/\1 /
+                       h
+                       $!d' | xargs -L 1 $XRANDR
 }
 
 load_cfg_disper() {
-       $DISPER -i < "$1"
+       $DISPER -i < "$1"
 }
 
 load() {
@@ -178,6 +227,7 @@ Usage: $SCRIPTNAME [options]
 -d, --default <profile> make profile <profile> the default profile 
 --force                        force (re)loading of a profile
 --fingerprint          fingerprint your current hardware setup
+--config               dump your current xrandr setup
 
  To prevent a profile from being loaded, place a script call "block" in its
  directory. The script is evaluated before the screen setup is inspected, and
@@ -199,7 +249,7 @@ EOH
        exit
 }
 # process parameters
-OPTS=$(getopt -n autorandr -o s:l:d:cfh --long change,default:,save:,load:,force,fingerprint,help -- "$@")
+OPTS=$(getopt -n autorandr -o s:l:d:cfh --long change,default:,save:,load:,force,fingerprint,config,help -- "$@")
 if [ $? != 0 ] ; then echo "Terminating..." >&2 ; exit 1 ; fi
 eval set -- "$OPTS"
 
@@ -212,6 +262,7 @@ while true; do
                -h|--help) help ;; 
                --force) FORCE_LOAD=1; shift ;;
                --fingerprint) setup_fp; exit 0;;
+               --config) current_cfg; exit 0;;
                --) shift; break ;;
                *) echo "Error: $1"; exit 1;;
        esac
@@ -223,7 +274,7 @@ if [ -n "$SAVE_PROFILE" ]; then
        echo "Saving current configuration as profile '${SAVE_PROFILE}'"
        mkdir -p "$PROFILES/$SAVE_PROFILE"
        echo "$CURRENT_SETUP" > "$PROFILES/$SAVE_PROFILE/setup"
-       current_cfg > "$PROFILES/$SAVE_PROFILE/config"
+       $CURRENT_CFG_METHOD > "$PROFILES/$SAVE_PROFILE/config"
        exit 0
 fi